<script lang="ts">
  import { page } from '$app/stores';
  import crystal_logo_light from '/crystal-logo-white.svg';
  import crystal_logo from '/crystal-logo.svg';
  import { isNavigating } from '$lib/navigation';
  import { onMount } from 'svelte';

  let y = 0;
  let width: 0;

  let isDark = false;
  onMount(() => {
    isDark = window.matchMedia('(prefers-color-scheme: dark)').matches;
    window.matchMedia('(prefers-color-scheme: dark)').addEventListener('change', event => {
      isDark = event.matches;
    });
  });
</script>

<svelte:window bind:scrollY={y} bind:innerWidth={width}/>

<div class="main">
  <div class="background" style="--opacity:{Math.min(Math.max(1 * y/100, 0), 0.75)};">
    <header >
      <div class="corner">
	<a href="/" class="name permalink">
	  {#if $isNavigating}
	    <span class="loader"></span>
	  {:else if isDark == false}
	    <img id="logo" src={y > 0 ? crystal_logo : crystal_logo_light} alt="crystal linux logo"/>
	  {:else}
	    <img id="logo" src={crystal_logo} alt="crystal linux logo"/>
	  {/if}
	  <p>Crystal Linux</p>
	</a>
      </div>

      <nav>
	<ul>
	  <li aria-current={$page.url.pathname === '/' ? 'page' : undefined}>
	    <a class="permalink" href="/">Home</a>
	  </li>
	  <li>
	    <a class="permalink" href="https://forum.getcryst.al">Forums</a>
	  </li>
	  <!--<li aria-current={$page.url.pathname === '/docs' ? 'page' : undefined}>
	      <a href="/docs">Docs</a>
	  </li>-->
	  {#if width > 800}
	    <li>
	      <a class="download" href="https://gitlab.com/crystal-linux/misc/iso/-/releases/permalink/latest">Download</a>
	    </li>
	  {/if}
	</ul>
      </nav>
    </header>
  </div>
  <slot />
</div>

<style lang="scss">
  @use "sass:color";

  @import "@fontsource-variable/playwrite-hr";

  .background {
    width: 100%;
    position: fixed;
    position: -webkit-sticky;
    top: 0;
    z-index: 99;
    height: 3.7em;
    backdrop-filter: blur(calc(10px * var(--opacity)));
    background-color: rgba(255, 255, 255, var(--opacity));
    @media (prefers-color-scheme: dark) {
      background-color: rgba(30, 30, 46, var(--opacity));
    }

    & header {
      display: flex;
      justify-content: space-between;
      align-items: center;
      width: 96%;
      position: fixed;
      position: -webkit-sticky;
      margin-left: 2%;
      opacity: 1;
      background-color: rgba(0,0,0,0);
    }
  }
  .name {
    font-size: 1.3em;
    font-weight: bold;
    padding-bottom: 6px;
  }

  .loader {
    width: 1.5em;
    height: 1.5em;
    border: 5px solid transparent;
    border-bottom-color: #E2122D;
    border-radius: 50%;
    display: inline-block;
    box-sizing: border-box;
    animation: rotation 1s linear infinite;
  }

  @keyframes rotation {
    0% { transform: rotate(0deg); }
    100% { transform: rotate(360deg); }
  }

  .corner {
    height: 3em;
    margin-bottom: 0px;

    & a {
      display: flex;
      align-items: center;
      justify-content: center;
      width: 100%;
      height: 100%;
      text-decoration: none;

      & p {
	padding-left: 4px;
      }
    }

    & img {
      width: 1.5em;
      height: 1.5em;
      object-fit: contain;
    }
  }


  nav {
    display: flex;
    justify-content: right;
    font-size: 1.2em;
    padding-right: 10px;
    object-fit: contain;
  }

  ul {
    position: relative;
    padding: 0;
    margin: 0;
    height: 3em;
    display: flex;
    justify-content: center;
    align-items: center;
    list-style: none;
    background-size: contain;
  }

  li {
    position: relative;
    align-content: center;
    height: 70%;

    & .download {
      background-color: #BFAFF2;
      user-select: none;
      padding: 0px 13px;
      border-radius: 9999px;

      cursor: pointer;
      color: black;
      background-color: color.adjust(#BFAFF2, $alpha: -0.1);
      min-width: 70px;
      max-width: 70vw;
      border-radius: 10px;
      align-items: center;
      justify-content: center;
      box-shadow: 0 1px 4px 1px color.change(black, $alpha: 0.10),
		  0 1px 10px 5px color.change(black, $alpha: 0.09),
		  0 3px 16px 8px color.change(black, $alpha: 0.04),
		  0 0 0 1px color.change(black, $alpha: 0.05);
      transition: box-shadow 0.3s ease-in-out;

      &:hover {
	box-shadow: 0 1px 4px 1px color.change(#BFAFF2, $alpha: 0.10),
		    0 1px 10px 5px color.change(#BFAFF2, $alpha: 0.09),
		    0 3px 16px 8px color.change(#BFAFF2, $alpha: 0.04),
		    0 0 0 1px color.change(#BFAFF2, $alpha: 0.05);
      }
    }
  }

  li[aria-current='page']::before {
    --size: 6px;
    content: '';
    width: 0;
    height: 0;
    position: absolute;
    top: 0;
    left: calc(50% - var(--size));
    border: var(--size) solid transparent;
    border-top: var(--size) solid var(--color-theme-1);
  }

  nav a {
    display: flex;
    height: 100%;
    align-items: center;
    padding: 0 0.5rem;
    font-weight: 700;
    font-size-adjust: 0.3;
    text-transform: uppercase;
    letter-spacing: 0.1em;
    text-decoration: none;
    transition: color 0.2s linear;
  }

</style>
